Bug 798871 - [RFP] Please add Vedic Extensions to Lohit fonts
[RFP] Please add Vedic Extensions to Lohit fonts
Status: CLOSED UPSTREAM
Product: Fedora
Classification: Fedora
Component: lohit-devanagari-fonts (Show other bugs)
23
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Pravin Satpute
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-03-01 02:01 EST by Shriramana Sharma
Modified: 2016-12-20 03:58 EST (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-12-20 03:11:52 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Additional glyphs for Vedic Extensions (14.88 KB, application/zip)
2012-07-06 21:43 EDT, Shriramana Sharma
no flags Details

  None (edit)
Description Shriramana Sharma 2012-03-01 02:01:27 EST
Description of problem:

It is very good that Red Hat / Fedora takes steps to update Lohit fonts with latest encoded Indic characters, especially Vedic characters included in Devanagari Extended block. (See https://www.redhat.com/archives/lohit-devel-list/2012-February/msg00011.html)

As a Sanskrit/Vedic scholar I very much welcome this. However, it would be even greater if the separate Vedic characters that are encoded in the Vedic Extensions block (http://www.unicode.org/charts/PDF/U1CD0.pdf) created in Unicode 5.2 along with Devanagari Extended were also supported.

As Devanagari is the script mainly used for Sanskrit and especially Vedic printings nowadays, it would be best to add the characters initially to the Lohit Devanagari font so that it can combine properly with the Devanagari characters. 

If at all there is future demand for the glyphs to be added to the font of another script (like Telugu etc which are also often used for Vedic texts in those areas) the glyphs can easily be copied to those fonts in the future.

OpenType normally cannot join base characters from one font with combining marks from a different font. So a separate Lohit Vedic font with purely Vedic characters is not possible.

As the glyphs from the Vedic Extensions block have very simple shapes, it would hopefully be easy to design those glyphs and add them to the fonts.

Version-Release number of selected component (if applicable):

2.5.1

How reproducible:

Install Lohit Devanagari 2.5.1 font.

Actual results:

The Devanagari-specific Vedic characters especially from the Devanagari Extended block are available. The generic Vedic characters from the Vedic Extensions block are not available.

Expected results:

It is desirable to have the generic Vedic characters from the Vedic Extensions block also.
Comment 1 Pravin Satpute 2012-03-01 02:28:30 EST
Sure, will look forward to this.
Comment 2 Shriramana Sharma 2012-03-01 03:29:39 EST
Thanks for your feedback. 

I also wanted to note that without the Vedic Extensions characters, even with only the Devanagari Extended characters, it is not possible to completely write the Sama Vedic texts. 

This is because the generic Vedic Extensions characters (especially KARSHANA, PRENKHA and SHARA) occur in combination with the Devanagari combining digits in Vedic texts. So we need both Vedic Extensions characters and Devanagari Extended characters to write these texts.

See the original Vedic proposal http://std.dkuug.dk/jtc1/sc2/wg2/docs/n3366.pdf pp 20 21 for samples.

Thanks.
Comment 3 Pravin Satpute 2012-03-01 04:11:44 EST
(In reply to comment #2)
> Thanks for your feedback. 
> 
> I also wanted to note that without the Vedic Extensions characters, even with
> only the Devanagari Extended characters, it is not possible to completely write
> the Sama Vedic texts. 
> 

That's good, I need one help from you. 
Presently we do not have any keyboard layout for inputting Vedic Extensions, have you seen any such? We should create one layout, might be we can append it on existing Devanagari based keyboard, Using AltGr modifier.
Comment 4 Shriramana Sharma 2012-03-01 06:05:22 EST
Hello thanks for showing interest in this. One gentleman from Russia has made some efforts towards this on Windows platform:

http://siddhanta.svayambhava.org/vaidika.zip (from http://svayambhava.org/index.php/en/fonts)

I am not saying his method should be adopted exactly, but you can have a look at it and we can consider it and develop a method accordingly.

I will also ask a respected for his inputs in this regard.
Comment 5 Shriramana Sharma 2012-03-01 06:06:49 EST
Hello thanks for showing interest in this. One gentleman from Russia has made some efforts towards this on Windows platform:

http://siddhanta.svayambhava.org/vaidika.zip (from http://svayambhava.org/index.php/en/fonts)

I am not saying his method should be adopted exactly, but you can have a look at it and we can consider it and develop a method accordingly.

I will also ask a respected scholar Dr Peter Scharf of Brown University who has worked on this (http://www.language.brown.edu/Sanskrit/VedicUnicode/) for his inputs in this regard.
Comment 6 Parag Nemade 2012-07-06 09:24:27 EDT
Moving to rawhide as new glyphs should go there first.
Comment 7 Shriramana Sharma 2012-07-06 21:43:21 EDT
Created attachment 596703 [details]
Additional glyphs for Vedic Extensions

Hello Pravin (and others).

So I suddenly wanted to finish this off and sat down and hacked for a few hours and this is the result. The attached TTF contains the requisite glyphs. 

I will not say that the glyphs are of super-duper quality (I am a Sanskrit scholar, not a professional typographer) but I hope they are acceptable. Especially one fault with some of the glyphs i.e. the ones I had to design using Inkscape and convert, viz 1CD7, 1CE0, 1CE1, 1CE3-1CEC and 1CEE-1CF1, have too many nodes, so if you look at them in the "Show nodes" mode of your font editor they will look horrible (i.e. the cluster of nodes). However, the actual rendering is fine, since the additional nodes are merely the result of stroking in Inkscape and then converting the 3rd order curves to 2nd order in Font Creator.

My additional glyphs are of course my contribution to the Lohit project under the OFL. I have attached the Inkscape SVG and the PDF with stroked glyphs also, under CC-BY-SA FWIW with the provision that resultant font glyphs shall be under the OFL.

I should note that the glyphs by themselves will not be sufficient to get proper rendering, and certainly some intricate smart-font programming and positioning will be necessary to get the actual result, but that is true of the other Vedic characters (i.e. mostly from Devanagari Extended block) already in the Lohit Devanagari font so I left it at that. 

Especially note that the non-spacing marks have zero advance width and are themselves horizontally centered at y-axis, and they will certainly have to be repositioned correctly above/below the orthographic syllable to get the correct effect. When I get time, I will sit and do Graphite programming for this, but not now as I have to get other things done.

I hope this contribution is acceptable. Thank you.
Comment 8 Shriramana Sharma 2012-07-06 22:03:03 EDT
BTW I should note that the two characters 1CF8 and 1CF9 are not yet encoded but have been approved and are in the pipeline (http://www.unicode.org/alloc/Pipeline.html) and will be probably published with the next version of Unicode or so. As these are rare use characters I hope there is no problem with including them.

[I may remark that the encoding proposals for 1CF3..1CF6 and the two above chars were authored by yours truly too ;-)]
Comment 9 Pravin Satpute 2012-07-11 01:54:23 EDT
Wow, thats nice.

I am thinking to release Lohit Vedic rather than making Lohit Devanagari to much bulky.

Reasoning behind it 
1) Vedic requires extra ascent and descent space. It will increase line spacing.
2) Regular Devanagari users does not required Vedic characters.
3) Having specific font for Vedic will give more flexibility to do changes.

Let me know your opinion on same. Discussion topic on Lohit devel actually.
Comment 10 Shriramana Sharma 2012-07-11 06:00:00 EDT
http://sanskrit1.ccv.brown.edu/tomcat/sl/accents.html has a list of combinations which are expected to render correctly and without overlap of combining marks. Enough testcases I suppose?
Comment 11 Fedora End Of Life 2013-04-03 13:08:45 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19
Comment 12 Fedora End Of Life 2015-01-09 12:02:32 EST
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 13 Fedora End Of Life 2015-05-29 04:43:05 EDT
This message is a reminder that Fedora 20 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 20. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '20'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 20 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 14 Pravin Satpute 2015-06-18 08:32:23 EDT
I do agree, its taking more time than expected. I need to find sometime for this.

Moving to next version.
Comment 15 Fedora End Of Life 2016-11-24 05:37:19 EST
This message is a reminder that Fedora 23 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 23. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '23'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 23 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 16 Pravin Satpute 2016-12-20 03:11:52 EST
Lohit is in maintenance mode. 
As commented earlier - We should ideally release Lohit Vedic fonts. Shriramana would you like to prepare Lohit Vedic? I can help to review and release it in upstream.

As of now - i am closing this issue in Fedora and moving in upstream.
Comment 17 Pravin Satpute 2016-12-20 03:58:02 EST
https://github.com/pravins/lohit/issues/81

Note You need to log in before you can comment on or make changes to this bug.